package packagePerformanceZoeEleve
  model PerformanceZoeEleve
    packagePerformanceZoeEleve.DCMotor dCMotor1(J = 0.11, L = 6e-03, R = 0.12, b = 0.025, kt = 1.27, t_m = 0.25) annotation(
      Placement(visible = true, transformation(origin = {-62, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Ground ground1 annotation(
      Placement(visible = true, transformation(origin = {-134, -58}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Sources.SignalVoltage signalVoltage1 annotation(
      Placement(visible = true, transformation(origin = {-134, -20}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
    Modelica.Blocks.Sources.Constant tensionAVide(k = 420) annotation(
      Placement(visible = true, transformation(origin = {-104, -20}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.LossyGear boiteVitesses(lossTable = [0, 0.99, 0.99, 0, 0], ratio = 2.3) annotation(
      Placement(visible = true, transformation(origin = {-30, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Resistor RinterneBatterie(R = 0.55) annotation(
      Placement(visible = true, transformation(origin = {-106, 12}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Translational.Components.Mass mass1 annotation(
      Placement(visible = true, transformation(origin = {70, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Translational.Sources.Force traineeAeroDynamique annotation(
      Placement(visible = true, transformation(origin = {110, 2}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
    Modelica.Blocks.Sources.RealExpression masseVolumiqueAir annotation(
      Placement(visible = true, transformation(origin = {110, -42}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Sources.RealExpression SCx annotation(
      Placement(visible = true, transformation(origin = {110, -58}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Sources.RealExpression vitesseCarre(y = mass1.v * mass1.v) annotation(
      Placement(visible = true, transformation(origin = {134, -72}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Math.Gain gain(k = -0.5) annotation(
      Placement(visible = true, transformation(origin = {182, -52}, extent = {{-6, -6}, {6, 6}}, rotation = 0)));
    Modelica.Blocks.Math.Product product1 annotation(
      Placement(visible = true, transformation(origin = {136, -46}, extent = {{-6, -6}, {6, 6}}, rotation = 0)));
    Modelica.Blocks.Math.Product product2 annotation(
      Placement(visible = true, transformation(origin = {160, -52}, extent = {{-6, -6}, {6, 6}}, rotation = 0)));
    Modelica.Mechanics.Translational.Sensors.SpeedSensor speedSensor2 annotation(
      Placement(visible = true, transformation(origin = {14, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Math.Gain vitesseKmParh(k = 3600 / 1000) annotation(
      Placement(visible = true, transformation(origin = {54, 60}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Translational.Sources.Force resistanceRoulement annotation(
      Placement(visible = true, transformation(origin = {112, 32}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
    Modelica.Blocks.Sources.RealExpression masseVoiture annotation(
      Placement(visible = true, transformation(origin = {110, 64}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Sources.RealExpression accelerationPesanteur annotation(
      Placement(visible = true, transformation(origin = {128, 48}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Sources.RealExpression Crr annotation(
      Placement(visible = true, transformation(origin = {150, 70}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Math.Product product3 annotation(
      Placement(visible = true, transformation(origin = {162, 52}, extent = {{-6, -6}, {6, 6}}, rotation = 0)));
    Modelica.Blocks.Math.Product product4 annotation(
      Placement(visible = true, transformation(origin = {184, 64}, extent = {{-6, -6}, {6, 6}}, rotation = 0)));
    Modelica.Blocks.Math.Gain gain1(k = -1) annotation(
      Placement(visible = true, transformation(origin = {174, 40}, extent = {{6, -6}, {-6, 6}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.Inertia inertiaRoues(J = 0.77 * 4) annotation(
      Placement(visible = true, transformation(origin = {4, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.IdealRollingWheel roues annotation(
      Placement(visible = true, transformation(origin = {38, 2}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
  equation
    connect(speedSensor2.v, vitesseKmParh.u) annotation(
      Line(points = {{25, 60}, {42, 60}}, color = {0, 0, 127}));
    connect(mass1.flange_a, speedSensor2.flange) annotation(
      Line(points = {{60, 2}, {58, 2}, {58, 34}, {-6, 34}, {-6, 60}, {4, 60}}, color = {0, 127, 0}));
    connect(roues.flangeT, mass1.flange_a) annotation(
      Line(points = {{48, 2}, {60, 2}, {60, 2}, {60, 2}}, color = {0, 127, 0}));
    connect(inertiaRoues.flange_b, roues.flangeR) annotation(
      Line(points = {{14, 2}, {28, 2}, {28, 2}, {28, 2}}));
    connect(boiteVitesses.flange_b, inertiaRoues.flange_a) annotation(
      Line(points = {{-20, 2}, {-6, 2}, {-6, 2}, {-6, 2}}));
    connect(dCMotor1.flange_b, boiteVitesses.flange_a) annotation(
      Line(points = {{-52, 2}, {-40, 2}}));
    connect(dCMotor1.pin_n, signalVoltage1.n) annotation(
      Line(points = {{-72, -3}, {-72, -34}, {-134, -34}, {-134, -30}}, color = {0, 0, 255}));
    connect(RinterneBatterie.n, dCMotor1.pin_p) annotation(
      Line(points = {{-96, 12}, {-72, 12}, {-72, 7}}, color = {0, 0, 255}));
    connect(resistanceRoulement.flange, mass1.flange_b) annotation(
      Line(points = {{102, 32}, {80, 32}, {80, 2}}, color = {0, 127, 0}));
    connect(resistanceRoulement.f, gain1.y) annotation(
      Line(points = {{124, 32}, {145, 32}, {145, 40}, {168, 40}}, color = {0, 0, 127}));
    connect(gain1.u, product4.y) annotation(
      Line(points = {{181.2, 40}, {195.2, 40}, {195.2, 64}, {189.2, 64}, {189.2, 64}}, color = {0, 0, 127}));
    connect(product3.y, product4.u2) annotation(
      Line(points = {{168.6, 52}, {172.6, 52}, {172.6, 60}, {176.6, 60}, {176.6, 60}}, color = {0, 0, 127}));
    connect(Crr.y, product4.u1) annotation(
      Line(points = {{161, 70}, {171, 70}, {171, 68}, {175, 68}, {175, 68}}, color = {0, 0, 127}));
    connect(masseVoiture.y, product3.u1) annotation(
      Line(points = {{121, 64}, {147, 64}, {147, 56}, {153, 56}, {153, 56}}, color = {0, 0, 127}));
    connect(accelerationPesanteur.y, product3.u2) annotation(
      Line(points = {{139, 48}, {153, 48}, {153, 48}, {153, 48}}, color = {0, 0, 127}));
    connect(gain.y, traineeAeroDynamique.f) annotation(
      Line(points = {{189, -52}, {192, -52}, {192, 2}, {122, 2}}, color = {0, 0, 127}));
    connect(vitesseCarre.y, product2.u2) annotation(
      Line(points = {{145, -72}, {150, -72}, {150, -56}, {153, -56}}, color = {0, 0, 127}));
    connect(product1.y, product2.u1) annotation(
      Line(points = {{142.6, -46}, {147.6, -46}, {147.6, -48}, {152.6, -48}}, color = {0, 0, 127}));
    connect(product2.y, gain.u) annotation(
      Line(points = {{166.6, -52}, {174.6, -52}}, color = {0, 0, 127}));
    connect(masseVolumiqueAir.y, product1.u1) annotation(
      Line(points = {{121, -42}, {129, -42}}, color = {0, 0, 127}));
    connect(SCx.y, product1.u2) annotation(
      Line(points = {{121, -58}, {125, -58}, {125, -50}, {129, -50}}, color = {0, 0, 127}));
    connect(signalVoltage1.v, tensionAVide.y) annotation(
      Line(points = {{-126, -20}, {-115, -20}}, color = {0, 0, 127}));
    connect(traineeAeroDynamique.flange, mass1.flange_b) annotation(
      Line(points = {{100, 2}, {80, 2}, {80, 2}, {80, 2}}, color = {0, 127, 0}));
    connect(RinterneBatterie.p, signalVoltage1.p) annotation(
      Line(points = {{-116, 12}, {-134, 12}, {-134, -10}, {-134, -10}}, color = {0, 0, 255}));
    connect(ground1.p, signalVoltage1.n) annotation(
      Line(points = {{-134, -48}, {-134, -48}, {-134, -30}, {-134, -30}}, color = {0, 0, 255}));
    annotation(
      Diagram(coordinateSystem(extent = {{-300, -500}, {300, 200}}, initialScale = 0.1), graphics = {Rectangle(origin = {-117, -22}, lineThickness = 1, extent = {{-37, 50}, {37, -50}}), Text(origin = {-125, 32}, lineThickness = 1, extent = {{-25, 4}, {25, -4}}, textString = "Batterie", fontName = "DejaVu Sans Mono"), Text(origin = {-48, -15}, lineThickness = 1, extent = {{-28, 1}, {16, -3}}, textString = "Moteur à courant continu", fontName = "DejaVu Sans Mono"), Text(origin = {71, -10}, lineThickness = 1, extent = {{-13, 4}, {13, -2}}, textString = "Masse voiture", fontName = "DejaVu Sans Mono"), Text(origin = {40, -13}, lineThickness = 1, extent = {{-14, 3}, {14, -5}}, textString = "transformation", fontName = "DejaVu Sans Mono"), Text(origin = {28, -20}, lineThickness = 1, extent = {{-8, 4}, {30, -2}}, textString = "Rotation Translation", fontName = "DejaVu Sans Mono"), Rectangle(origin = {144, -34}, lineThickness = 1, extent = {{-54, 50}, {54, -50}}), Text(origin = {160, 11}, lineThickness = 1, extent = {{-24, 3}, {34, -5}}, textString = "Trainée aérodynamique", fontName = "DejaVu Sans Mono"), Rectangle(origin = {144, 49}, lineThickness = 1, extent = {{-54, 31}, {54, -31}}), Text(origin = {158, 25}, lineThickness = 1, extent = {{-24, 3}, {34, -5}}, textString = "Résistance au roulement", fontName = "DejaVu Sans Mono")}),
      Icon(coordinateSystem(extent = {{-300, -500}, {300, 200}})),
      version = "",
      uses(Modelica(version = "3.2.2")),
      __OpenModelica_commandLineOptions = "",
      experiment(StartTime = 0, StopTime = 60, Tolerance = 1e-06, Interval = 0.12));
  end PerformanceZoeEleve;

  class DCMotor "DC Motor"
    //Icon
    extends Modelica.Icons.MotorIcon;
    //extends Servomechanisms.Utilities.IconName;
    //Parameters
    parameter Modelica.SIunits.Resistance R = 0.128 "Armature Resistance";
    parameter Modelica.SIunits.Inductance L = 0.000062 "Armature Inductance";
    parameter Modelica.SIunits.ElectricalTorqueConstant kt = 0.0305 "Torque Constant";
    parameter Modelica.SIunits.Inertia J = 0.000121 "Rotor Inertia";
    parameter Modelica.SIunits.RotationalDampingConstant b = 0 "Damping Factor";
    parameter Modelica.SIunits.Torque t_m = 0.001 "Max. Friction torque";
    //Components
    Modelica.Electrical.Analog.Basic.Resistor resistor(R = R) annotation(
      Placement(visible = true, transformation(origin = {-75, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.Inductor inductor(L = L) annotation(
      Placement(visible = true, transformation(origin = {-25, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Basic.EMF emf(k = kt) annotation(
      Placement(visible = true, transformation(origin = {0, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.Inertia inertia(J = J) annotation(
      Placement(visible = true, transformation(origin = {75, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.Damper damper(d = b) annotation(
      Placement(visible = true, transformation(origin = {60, -25}, extent = {{-10, -10}, {10, 10}}, rotation = 90)));
    Modelica.Mechanics.Rotational.Components.Fixed fixed annotation(
      Placement(visible = true, transformation(origin = {60, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Components.BearingFriction bearingfriction(peak = 1, tau_pos = [0, t_m]) annotation(
      Placement(visible = true, transformation(origin = {40, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    //Sensors
    Modelica.Mechanics.Rotational.Sensors.AngleSensor anglesensor annotation(
      Placement(visible = true, transformation(origin = {75, 50}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
    Modelica.Mechanics.Rotational.Sensors.SpeedSensor speedsensor annotation(
      Placement(visible = true, transformation(origin = {75, 25}, extent = {{10, -10}, {-10, 10}}, rotation = 0)));
    //Interfaces
    Modelica.Mechanics.Rotational.Interfaces.Flange_b flange_b annotation(
      Placement(visible = true, transformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {100, 0}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.NegativePin pin_n annotation(
      Placement(visible = true, transformation(origin = {-100, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0), iconTransformation(origin = {-100, -50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Electrical.Analog.Interfaces.PositivePin pin_p annotation(
      Placement(visible = true, transformation(origin = {-100.902, 49.0984}, extent = {{-9.09836, -9.09836}, {9.09836, 9.09836}}, rotation = 0), iconTransformation(origin = {-100, 50}, extent = {{-10, -10}, {10, 10}}, rotation = 0)));
    Modelica.Blocks.Interfaces.RealOutput angle annotation(
      Placement(visible = true, transformation(origin = {50, 50}, extent = {{10, -10}, {-10, 10}}, rotation = 0), iconTransformation(origin = {-50, -100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
    Modelica.Blocks.Interfaces.RealOutput speed annotation(
      Placement(visible = true, transformation(origin = {50, 25}, extent = {{10, -10}, {-10, 10}}, rotation = 0), iconTransformation(origin = {50, -100}, extent = {{-10, -10}, {10, 10}}, rotation = -90)));
  equation
    connect(speedsensor.w, speed) annotation(
      Line(points = {{64, 25}, {56.2061, 25}, {56.2061, 24.356}, {56.2061, 24.356}}));
    connect(anglesensor.phi, angle) annotation(
      Line(points = {{64, 50}, {57.1429, 50}, {57.1429, 48.7119}, {57.1429, 48.7119}}));
    connect(speedsensor.flange, flange_b) annotation(
      Line(points = {{85, 25}, {100.234, 25}, {100.234, 0}, {100.234, 0}}));
    connect(anglesensor.flange, flange_b) annotation(
      Line(points = {{85, 50}, {100.234, 50}, {100.234, 0.468384}, {100.234, 0.468384}}));
    connect(fixed.flange, damper.flange_a) annotation(
      Line(points = {{60, -50}, {59.9532, -50}, {59.9532, -35.1288}, {59.9532, -35.1288}}));
    connect(damper.flange_b, inertia.flange_a) annotation(
      Line(points = {{60, -15}, {60, 0}, {64.637, 0}, {64.637, 0}}));
    connect(inertia.flange_b, flange_b) annotation(
      Line(points = {{85, 0}, {97.8923, 0}, {97.8923, -1.40515}, {97.8923, -1.40515}}));
    connect(bearingfriction.flange_b, inertia.flange_a) annotation(
      Line(points = {{50, 0}, {65.1054, 0}, {65.1054, -0.936768}, {65.1054, -0.936768}}));
    connect(emf.flange, bearingfriction.flange_a) annotation(
      Line(points = {{10, 0}, {30.445, 0}, {30.445, -0.468384}, {30.445, -0.468384}}));
    connect(inductor.n, emf.p) annotation(
      Line(points = {{-15, 50}, {0.468384, 50}, {0.468384, 9.83607}, {0.468384, 9.83607}}));
    connect(pin_n, emf.n) annotation(
      Line(points = {{-100, -50}, {0.936768, -50}, {0.936768, -10.7728}, {0.936768, -10.7728}}));
    connect(resistor.n, inductor.p) annotation(
      Line(points = {{-65, 50}, {-34.6604, 50}, {-34.6604, 50.1171}, {-34.6604, 50.1171}}));
    connect(resistor.p, pin_p) annotation(
      Line(points = {{-85, 50}, {-100.234, 50}, {-100.234, 48.7119}, {-100.234, 48.7119}}));
    annotation(
      Documentation(info = "<html>
  <head>
  <style type=\"text/css\">
  h4      { border-radius:8%;background-color: #D8D8D8 ;}
  </style>
  </head>
  
  <h4>General</h4>
  <p>
  This is the model of a permanent magnet DC motor, one of the most common electromechanical actuator 
  with caractheristics as low inductance and low friction.
  It includes dead zone.
  </p>
  
  <h4>Implementation</h4>
  <strong>DCMotor</strong> is based upon the mathematical model of a 
  permanent magnet dc motor.
  It is similar to the
  <a href=\"modelica://Servomechanisms.Electrical.IdealDCMotor\">
  IdealDCMotor
  </a> 
  class but this model is nonlinear. A dead zone is added by 
  using the static friction of 
  <a href=\"modelica://Modelica.Mechanics.Rotational.Components.BearingFriction\">
  BearingFriction
  </a>
  component.<br>
  Using elements from 
  <a href=\"modelica://Modelica\">MSL</a>  
  the model was developed to represent the mathematical equations:<br>
  <img src=\"modelica://Servomechanisms/Resources/Images/Electrical/dcmotorequation.png\" alt=\"dcmotorequation.png\" >
  
  <h4>Notes</h4>
  <ul>
  <li>
  The behavior of the voltage source is given by a <strong>real input</strong> (for example a real source block could be connected as an input, see 
  <a href=\"modelica://Modelica.Blocks.Sources\">Modelica.Blocks.Sources</a>  
  ).
  </li>
  <li>This model is linear</li>
  <li>All the parameters and variables are in SI units</li>
  <li>Has angle and speed sensors as <strong>real outputs</strong> .</li>
  </ul>
  
  
  </html>"),
      Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})),
      Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Text(origin = {-38.7173, -67.4584}, lineColor = {255, 255, 255}, extent = {{-14.4893, 12.3515}, {14.4893, -12.3515}}, textString = "Phi", fontSize = 30), Text(origin = {50.6413, -66.9359}, extent = {{-14.4893, 12.3515}, {14.4893, -12.3515}}, textString = "w", fontSize = 30)}));
  end DCMotor;

  partial record IconName
    annotation(
      Documentation(info = "<html>
<head>
<style type=\"text/css\">
h4      { border-radius:8%;background-color: #D8D8D8 ;}
</style>
</head>

<h4>General</h4>
<p>
Icon element.
</p>
</html>"));
    annotation(
      Diagram(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2})),
  Icon(coordinateSystem(extent = {{-100, -100}, {100, 100}}, preserveAspectRatio = true, initialScale = 0.1, grid = {2, 2}), graphics = {Text(lineColor = {0, 0, 255}, extent = {{-150, 150}, {150, 110}}, textString = "%name")}));
  end IconName;
  annotation(
    uses(Modelica(version = "3.2.2")));
end packagePerformanceZoeEleve;
